/*
   This is the checking program to problem C ('Szkoly')

   Author : Bartosz Nowierski
*/

#include <stdio.h>

#define MAX 1000

int G[MAX][MAX];
int N, M;
int U[MAX];
int A[MAX];


int main(int argc, char *argv[])
{
  char inname[1000], outname[1000], toutname[1000];
  FILE *fin, *fout, *ftout;
  int sets;
  int i, j;
  char odp[1000];
  int v1, v2;
  int cnt;


  if (argc < 3)
  {
    fprintf(stderr, "not enough arguments\n");
    return 255;
  }
  sprintf(inname, "%s/input", argv[1]);
  sprintf(outname, "%s/output", argv[1]);
  sprintf(toutname, "%s/output", argv[2]);

  fin = fopen(inname, "r");
  fout = fopen(outname, "r");
  ftout = fopen(toutname, "r");
  if (fin == NULL || fout == NULL || ftout == NULL)
  {
    fprintf(stderr, "couldn't open files\n");
    return 255;
  }

  fscanf(fin, "%d", &sets);
  while (sets--)
  {
    if (fscanf(fin, "%d%d", &N, &M) < 2)
    {
      fprintf(stderr, "error while reading graph size\n");
      return 255;
    }
    for (i = 0; i < N; ++i)
    {
      for (j = 0; j < N; ++j)
      {
        G[i][j] = 0;
      }
    }
    for (i = 0; i < M; ++i)
    {
      if (fscanf(fin, "%d%d", &v1, &v2) < 2)
      {
        fprintf(stderr, "error while reading edges\n");
        return 255;
      }
      --v1;
      --v2;
      G[v1][v2] = 1;
      G[v2][v1] = 1;
    }

    if (fscanf(fout, "%s", odp) < 1)
    {
      fprintf(stderr, "error while reading correct answer\n");
      return 255;
    }

    if (strcmp(odp, "NIE") == 0)
    {
      if (fscanf(ftout, "%s", odp) < 1)
      {
        return 1;
      }
      if (strcmp(odp, "NIE") != 0)
      {
        return 1;
      }
    }
    else
    {
      for (i = 0; i < N; ++i)
      {
        U[i] = 0;
      }
      cnt = 0;
      while (1)
      {
        if (fscanf(ftout, "%d", &A[cnt]) < 1)
        {
          return 1;
        }
        if (A[cnt] == -1)
        {
          break;
        }
        --A[cnt];
        if (U[A[cnt]])
        {
          return 1;
        }
        U[A[cnt]] = 1;
        ++cnt;
      }
      for (i = 0; i < cnt; ++i)
      {
        for (j = i+1; j < cnt; ++j)
        {
          if (G[A[i]][A[j]])
          {
            return 1;
          }
        }
      }
      cnt = 0;
      for (i = 0; i < N; ++i)
      {
        if (!U[i])
        {
          A[cnt] = i;
          ++cnt;
        }
      }
      for (i = 0; i < cnt; ++i)
      {
        for (j = i+1; j < cnt; ++j)
        {
          if (G[A[i]][A[j]])
          {
            return 1;
          }
        }
      }
    }
    printf("OK\n");
  }

  fclose(fin);
  fclose(fout);
  fclose(ftout);

  return 0;
}
